//*************************************************
// ANTIFURTO CASA BASE 1.1
// Firmware: ACB1.1
// Scheda: DVD-0006-03
// modulo: main.c
// Autore: Davide Stecco
// Data: 09/05/2011
// Descrizione: Automazione tapparelle e antifurto
// picmicro: PIC16F876A
// clock: 4MHz
//*************************************************

unsigned char ScattiMax;                //Variabile Scatti tapparella massimi
unsigned char RitChius;                 //Variabile Ritardo alla chiusura quando l'antifurto  attivato
unsigned char RitApert;                 //Variabile Ritardo apertura quando l'antifurto  disattivato
unsigned char ScattiMem;                //Variabile Memorizzazione degli scatti
unsigned char cnt;                      //Variabile di conteggio
unsigned char OldState;
unsigned char CntAll;
unsigned int CntReset;

#define ANTI1 Button(&PORTB,0,1,1)          //Ingresso RB0 antifurto abilitazione antifurto
#define ANTI2 RB1_bit                       //Ingresso RB1 antifurto (da vedere)
#define PULSSU Button(&PORTB,2,10,0)         //Ingresso RB2 pulsante su
#define PULSGIU Button(&PORTB,3,10,0)        //Ingresso RB3 pulsante giu
#define TAPPA RB4_bit                       //Ingresso RB4 contatto tapparella
#define FINES RB5_bit                       //Ingresso RB5 contatto finestra
#define RAD1 Button(&PORTB,6,1,1)           //Ingresso RB6 contatto radio 1
#define RAD2 Button(&PORTB,7,1,1)           //Ingresso RB7 contatto radio 2

#define OUTSU PORTC.B0                      //Uscita Motore SU
#define OUTGIU PORTC.B1                     //Uscita Motore GIU

#define AntNormTap PORTC.B2                 //Uscita antifurto 1 sezione 1
#define AntSabotTap PORTC.B3                //Uscita antifurto 1 sezione 2
#define AntNormFin PORTC.B4                 //Uscita antifurto 2 sezione 1
#define AntSabotFin PORTC.B5                //Uscita antifurto 2 sezione 2

#define BUZZER PORTA.B5                     //Uscita buzzer
#define SEGNALA PORTA.B2                    //Uscita Segnalazione LED
#define SIRENA PORTA.B3                     //Uscita Sirena (opzionale)

#define TapAlla 1
#define TapFerm 0

// Definizione delle funzioni :
void Salita (void);
void Discesa (void);
void AntOn (void);
void AntOff (void);
void Allarme (void);



void main (void){
        // ********************************
        // Inizializzazione PIC
        // ********************************

        // Imposto PORTA come uscite
        TRISA = 0;
        PORTA = 0;

        // Imposto PORTB come ingressi
        TRISB        = 0xFF;

        // Imposto PORTC come uscite
        TRISC = 0;
        PORTC = 0;

        // Imposto gli interrupt
         INTCON = 0x00;
         OPTION_REG = 0x00;
        //resetto le uscite d'allarme per non avere problemi sull'antifurto.        
        AntNormTap = 1;
        AntSabotTap = 1;
        AntNormFin = 1;
        AntSabotFin = 1;
        // Leggo la EEPROM e li memorizzo nelle variabili
        //        da fare pi avanti
        ScattiMax = Eeprom_Read(0);
        Delay_ms(500);
        RitChius = Eeprom_Read(1);
        Delay_ms(500);
        RitApert = Eeprom_Read(2);
        Delay_ms(500);
        ScattiMem = Eeprom_Read(3);


        
        ScattiMax  = 250;
        RitChius = 60;
        RitApert = 60;
        //SIRENA = 1;
        //Delay_ms(1000);
        //SIRENA = 0;
        //SEGNALA = 1;
        //Delay_ms(1000);
        //SEGNALA = 0;
        //BUZZER = 1;
        //Delay_ms(1000);
        //BUZZER = 0;
        
        if(ANTI2 == 1){
                 OldState = 0;
             }
        if(ANTI2 == 0 && OldState == 0){
                  OldState = 1;
             }
          while(1) {
          // Controllo il pulsante di salita
          if(PULSSU) {
                     Salita();
          }
          // Controllo il pulsante di discesa
          if(PULSGIU) {
                      Discesa();
          }
          if(ANTI2 == 1 && OldState == 1){
                         OldState = 0;
                         AntOff();
          }
          if(ANTI2 == 0 && OldState == 0){
                         OldState = 1;
                         AntOn();
          }
          if(FINES == 0) {
                    AntNormFin = 1;
          }
          if(FINES == 1) {
                  AntNormFin = 0;
          }
          if (TAPPA == TapAlla) {
              while(TAPPA == TapAlla){
              }
           CntAll++;
          }
          if (CntAll > 3) {
               Allarme();
               Delay_ms(1000);
               CntAll = 0;
          }
          CntReset++;
          if (CntReset > 65000) {
                   CntReset = 0;
                   CntAll = 0;
          }
          }
}

void Salita (void){
     Delay_ms(100);
        OUTGIU = 0;                      //spengo per sicurezza il motore GIU
        cnt = 0;                         //Azzero la variabile
        OUTSU = 1;                       //Accendo il motore SU
        Delay_ms(1000);
        if(PULSSU){
          while(PULSSU){
                  OUTSU = 1;
                  Delay_ms(10);
                  }
        }else{
            for(cnt = 0; cnt < ScattiMax; cnt++){  //Ciclo di pausa
                Delay_ms(100);
                if (PULSSU) {
                  goto FermaSalita;
                }
                if (PULSGIU) {
                  goto FermaSalita;
                }
            }
        }
        OUTSU = 0;                       //Spengo il motore SU
        FermaSalita:
        Delay_ms(200);
}

void Discesa (void){
        if (FINES == 0){
        Delay_ms(100);
        OUTSU = 0;                        //spengo per sicurezza il motore SU
        cnt = 0;                          //Azzero la variabile
        OUTGIU = 1;                       //Accendo il motore GIU
        Delay_ms(1000);
        if(PULSGIU){
          while(PULSGIU){
                  OUTGIU = 1;
                  Delay_ms(10);
          }
        }else{

            for(cnt = 0; cnt < ScattiMax; cnt++){  //Ciclo di pausa
                Delay_ms(100);
                if (PULSSU) {
                   goto FermaDiscesa;
                }
                if (PULSGIU) {
                   goto FermaDiscesa;
                }
                if (FINES == 1) {
                   goto FermaDiscesa;
                    }
                }
            }
        }else{
                  while(PULSGIU){
                  OUTGIU = 1;
                  Delay_ms(10);
                  }
          }
        OUTGIU = 0;                      //spengo il motore GIU
        FermaDiscesa:
        Delay_ms(200);
}

void Allarme (void){

for(cnt = 0; cnt < 20; cnt++){
     SEGNALA = 1;
     BUZZER = 1;
     if (TAPPA == TapAlla) {
          AntNormTap = 0;
     }
     Delay_ms(200);
     SEGNALA = 0;
     BUZZER = 0;
     Delay_ms(200);
}
for(cnt = 0; cnt < 255; cnt++){
     if (TAPPA == TapAlla) {
          AntNormTap = 0;
     }
     Delay_ms(100);
}
BUZZER = 0;
SEGNALA = 0;
Delay_ms(5000);
AntNormTap = 1;
}

void AntOff (void){
  cnt = 0;
  OUTGIU = 0;
  OUTSU = 0;
  for(cnt = 0; cnt < RitApert; cnt++){   //Ciclo di pausa
          Delay_ms(1000);
        }
  if(ANTI2 == 1){
            Salita();
     }
}

void AntOn (void){
  cnt = 0;
  OUTSU = 0;
  OUTGIU = 0;
  for(cnt = 0; cnt < RitApert; cnt++){   //Ciclo di pausa
          Delay_ms(1000);
        }
   if(ANTI2 == 0){
            Discesa();
     }
}